/* Generated by re2c 2.2 on Fri May 26 06:50:08 2023 */
#line 1 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"

/*
 * requires re2c (http://re2c.org)
 *
 */

#include <stdio.h>
#include <stdarg.h>
#include <ctype.h>
#include <string.h>

#include <unistd.h>
#include <signal.h>

#include "defc.h"
#include "disasm.h"


extern char *x_readline(const char *prompt);

extern int g_fullscreen;
extern int g_config_control_panel;
extern Engine_reg engine;
extern int halt_sim;


int g_num_mp_breakpoints = 0;
word32 g_mp_breakpoints[MAX_BREAK_POINTS];

int g_num_bp_breakpoints = 0;
word32 g_bp_breakpoints[MAX_BREAK_POINTS];

int g_num_tp_breakpoints = 0;
word32 g_tp_breakpoints[MAX_BREAK_POINTS];

int g_dbg_shell = 0;
int g_stepping = 0;

word32 g_abort_address = 0;
word32 g_abort_value = 0;
word32 g_abort_bytes = 0;


static word32 g_prev_address = 0;
static word32 g_prev_stack_address = 0;
static word32 g_prev_stack_bank = 0;


static int g_templates_loaded = 0;
extern void debug_load_templates(const char *path);
extern word32 debug_apply_template(word32 address, const char *name);
extern void debug_load_nifty(const char *path);
extern const char *debug_tool_name(unsigned number, unsigned vector, unsigned full);



#if defined(__APPLE__)
#include <mach-o/dyld.h>
static char *get_resource_path(const char *leaf) {

	uint32_t size = 0;
	char *buffer = 0;
	int ok;
	char *cp;
	int l;

	l = strlen(leaf);
	ok = _NSGetExecutablePath(NULL, &size);
	size += l + 1 + sizeof("Resources/");
	buffer = malloc(size);
	if (!buffer) return NULL;

	/*
	 * expect .../GSPlus.app/Contents/MacOS/GSPlus
	 * drop
	 */
	ok = _NSGetExecutablePath(buffer, &size);
	if (ok < 0) {
		free(buffer);
		return NULL;
	}
	cp = strrchr(buffer, '/');
	if (!cp) { free(buffer); return NULL; }
	*cp = 0;
	cp = strrchr(buffer, '/');
	if (!cp) { free(buffer); return NULL; }

	strcpy(cp + 1, "Resources/");
	strcat(cp, leaf);

	return buffer;	
}
#elif defined(_WIN32)
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
/* todo -- something clever like find the home directory */
static char *get_resource_path(const char *leaf) {
	DWORD size;
	char *buffer = 0;
	char *cp;
	int l;

	l = strlen(leaf);

	size = GetModuleFileName(NULL, buffer, 0);
	if (size == 0) return strdup(leaf);

	size += l + 2;
	buffer = malloc(size);
	if (!buffer) return NULL;

	size = GetModuleFileName(NULL, buffer, size);
	if (!size) return strdup(leaf);

	cp = strrchr(buffer, '\\');
	strcpy(cp + 1, leaf);
	return buffer;
}
#else
static char *get_resource_path(const char *leaf) {
	int l;
	char *cp;
	static char path[] = "/usr/local/share/gsplus/";
	l = strlen(leaf);
	cp = malloc(l + sizeof(path) + 1);
	if (!cp) return NULL;
	strcpy(cp, path);
	strcat(cp, leaf);
	return cp;
}
#endif

void clear_line(void) {
	/* carriage return, clear_eol */
	/* cr, ce */
	fputs("\r\x1b[K", stdout);
}

void clear_prev_line(void) {
	/* carriage return, cursor_up, clear_eol */
	/* cr, up, ce */
	fputs("\r\x1b[A\x1b[K", stdout);

}


/*
 * todo 
 * - tool break support
 * - gs/os break support
 * - p8 break support
 * - r -> run to next rts/rtl
 * - ! -> mini assembler
 */



static void do_handle(word32 value, int action) {
	/* action = I)nfo, W)who, H)handle */

	enum {
		MemList	= 0xe11600,
		PurgeList = 0xe11604,
		FreeList = 0xe11608
	};

	enum {
		offset_address = 0,
		offset_attr = 4,
		offset_owner = 6, 
		offset_size = 8,
		offset_prev = 12,
		offset_next = 16 
	};

	unsigned mask = 0;
	unsigned count = 0;

	/* return information on who owns an address. */
	/* Nifty list can get info from the GS/OS... we can't */

	fputs("handle addr   size   flgs ownr\n", stdout);
	fputs("------ ------ ------ ---- ----\n", stdout);


	if (action == 'i') {
		value &= 0xffff;
		mask = 0x0000;
		if (value & 0xf000) mask |= 0xf000;
		if (value & 0x0f00) mask |= 0x0f00;
		if (value & 0x00f0) mask |= 0x00f0;
		if (value & 0x000f) mask |= 0x000f;
	}

	for (unsigned i = 0; i < 2; ++i) {

		word32 handle;
		handle = get_memory24_c(i == 0 ? MemList : PurgeList, 0);

		for(; handle ; handle = get_memory24_c(handle + offset_next, 0)) {

			word32 address = get_memory32_c(handle + offset_address, 0);
			word32 size = get_memory24_c(handle + offset_size, 0);
			unsigned owner = get_memory16_c(handle + offset_owner, 0);
			unsigned attr = get_memory16_c(handle + offset_attr, 0);

			/* size not 32-bit clean.  may be $ffxxxxxx */

			if (action == 'w') {
				if (value < address || value >= address + size) continue;
			}

			if (action == 'i') {
				if ((owner & mask) != value) continue;
			}

			if (action == 'h') {
				if (value != handle) continue;
			}

			fprintf(stdout, "%06x %06x %06x %04x %04x\n",
				handle, address, size, attr, owner
			);
			++count;
			if (action == 'w' || action == 'h') break;
		}

		if (action == 'w') break;
		if (action == 'h' && handle) break;
	}


	if (action == 'w' && !count) {
		fputs("not allocated\n", stderr);
	}
	if (action == 'h' && !count) {
		fputs("not handle\n", stderr);
	}

}


word32 tool_lookup(unsigned tool) {
	enum {
		TPtr = 0xe103c0,
		UTPtr = 0xe103c4,
	};

	unsigned tn = tool & 0xff;
	unsigned ix = (tool >> 8) & 0xff;
	word32 ptr;
	word32 count;

	ptr = get_memory32_c(TPtr, 0);
	if (ptr == 0 || ptr > 0xffffff) return 0;

	count = get_memory32_c(ptr, 0);
	if (count == 0 || count > 255 || count < tn) return 0;
	ptr = get_memory32_c(ptr + tn * 4, 0);
	if (ptr == 0 || ptr > 0xffffff) return 0;

	count = get_memory32_c(ptr, 0);
	if (count == 0 || count > 255) return 0;
	if (ix && ix > count) return 0;

	/* if ix == 0, list all tool calls in the set */
	/* otherwise, just the specific tool call */

	/* todo -- also lookup tool name */
	word32 addr = 0;
	const char *cp;
	if (ix) {
		unsigned n = tn + (ix << 8);
		addr = get_memory24_c(ptr + ix * 4, 0);
		if (addr) ++addr;
		cp = debug_tool_name(n, 0xe10000, 1);
		if (!cp) cp = "---unknown---";
		printf("%04x  (%06x)  %s\n", n, addr, cp);
	} else {
		for(ix = 1; ix < count; ++ix) {
			unsigned n = tn + (ix << 8);

			addr = get_memory24_c(ptr + ix * 4, 0);
			if (addr) ++addr;
			cp = debug_tool_name(n, 0xe10000, 1);
			if (!cp) cp = "---unknown---";
			printf("%04x  (%06x)  %s\n", n, addr, cp);
		}
	}

	return addr;
}

word32 do_hexdump(word32 address, int lines) {
	static char hex[] = "0123456789abcdef";

	char buffer1[64];
	char buffer2[20];
	int i;

	while (--lines) {
		char *cp = buffer1;
		for (i = 0; i < 16; ++i) {
			uint8_t c = get_memory_c(address + i, 0);
			*cp++ = hex[c >> 4];
			*cp++ = hex[c & 0x0f];
			*cp++ = ' ';
			if (i == 7) *cp++ = ' ';

			buffer2[i] = (c < 0x80) && isprint(c) ? c : '.';
		}
		*cp = 0;
		buffer2[16] = 0;
		printf("%02x/%04x: %s  %s\n",
			address >> 16, address & 0xffff,
			buffer1, buffer2
			);
		address += 16;
		address &= 0xffffff;
	}

	return address;
}

static int check_stack_rts(word32 address, unsigned bank, char *buffer) {
	word32 rt;
	unsigned op;

	rt = get_memory24_c(address, 0);
	if (rt == 0) return 0;

	rt = (rt & 0xff0000) | ((rt - 3) & 0xffff);
	op = get_memory_c(rt, 0);
	if (op == 0x22) {
		word32 tmp = get_memory24_c(rt + 1, 0); /* crosses bank :/ */
		/* todo -- check if tmp is known address, include below */
		/* todo -- if jsl e10000, check for prev. ldx # */
		sprintf(buffer, "%02x/%04x: JSL %06x",
			rt >> 16, rt & 0xffff, tmp);
		return 3;
	}
	/* sigh... this might re-check 0000 a lot */
	rt = get_memory16_c(address, 0);
	rt = bank | ((rt - 2) & 0xffff);

	op = get_memory_c(rt, 0);
	if (op == 0x20 || op == 0xfc) {
		word32 tmp = get_memory16_c(rt + 1, 0);
		if (op == 0x20) {
			sprintf(buffer, "%02x/%04x: JSR %04x",
				rt >> 16, rt & 0xffff, tmp);
		}
		if (op == 0xfc) {
			sprintf(buffer, "%02x/%04x: JSR (%04x,x)",
				rt >> 16, rt & 0xffff, tmp);	
		}

		return 2;
	}


	return 0;
}

word32 do_stack(word32 address, unsigned bank) {

	/* scan through stack.
	 * if address looks like jsr return address
	 * or jsl return address, print it.
	 * otherwise, hexdump it.
	 *
	 * jsr absolute = 0x20
	 * jsr (absolute,x) = 0xfc
	 * jsl abslong = 0x22
	 *
	 *
	 * TODO - in Niftylist, JSL updates the bank.
	 * TODO - don't display c000, etc.
	 */

	static char hex[] = "0123456789abcdef";

	char buffer1[64];
	char buffer2[64];

	unsigned offset = 0;
	unsigned line = 0;
	char *cp = buffer1;

	++address;

	while(line < 20) {
		unsigned c;
		int tmp = check_stack_rts(address + offset, bank, buffer2);
		if (tmp) {
			/* flush any pending data */

			if (offset) {
				*cp = 0;
				printf("%02x/%04x: %s\n",
					address >> 16, address & 0xffff, buffer1);
				++line;
				address += offset;
				offset = 0;
				cp = buffer1;
			}

			for (offset = 0; offset < tmp; ++offset) {
				c = get_memory_c(address + offset, 0);
				*cp++ = hex[c >> 4];
				*cp++ = hex[c & 0x0f];
				*cp++ = ' ';
			}

			*cp = 0;
			printf("%02x/%04x: %-12s%s\n",
				address >> 16, address & 0xffff, buffer1, buffer2);
			++line;
			address += offset;
			offset = 0;
			cp = buffer1;
			continue;
		}

		c = get_memory_c(address + offset, 0);
		*cp++ = hex[c >> 4];
		*cp++ = hex[c & 0x0f];
		*cp++ = ' ';

		if (offset == 7) *cp++ = ' ';
		++offset;

		if (offset == 16) {
			*cp = 0;
			printf("%02x/%04x: %s\n",
				address >> 16, address & 0xffff, buffer1);
			++line;
			address += offset;
			offset = 0;
			cp = buffer1;
		}
	}

	return address;

}


static int is_jsl_e10000(word32 address) {
	return get_memory_c(address, 0) == 0x22 &&
		get_memory24_c(address + 1, 0) == 0xe10000;
}

static int is_jsl_e10008(word32 address) {
	return get_memory_c(address, 0) == 0x22 &&
		get_memory24_c(address + 1, 0) == 0xe10008;
}
static int is_jsl_e100a8(word32 address) {
	return get_memory_c(address, 0) == 0x22 &&
		get_memory24_c(address + 1, 0) == 0xe100a8;
}


static int is_jsl_e100b0(word32 address) {
	return get_memory_c(address, 0) == 0x22 &&
		get_memory24_c(address + 1, 0) == 0xe100b0;
}

static int is_jsr_bf00(word32 address) {
	return get_memory_c(address, 0) == 0x20 &&
		get_memory16_c(address + 1, 0) == 0xbf00;
}

int g_disasm_psr;

static const char *get_inline_debug_name(word32 address) {
	static char buffer[256];

	/* see IIgs technote #103 */
	/* 82 xx xx brl pastname
	   71 77
	   name
	   pastname:
	 */

	/* uthernet uses bra ... tsk tsk. */

	int match = 0;
	int offset = 0;

	unsigned op = get_memory_c(address, 0);
	if (op == 0x82
		&& get_memory_c(address + 3, 0) == 0x71
		&& get_memory_c(address + 4, 0) == 0x77) {
		match = 1;
		address += 5;

		offset = (int16_t)get_memory16_c(address + 1, 0);
	}

	if (op == 0x80
		&& get_memory_c(address + 2, 0) == 0x71
		&& get_memory_c(address + 3, 0) == 0x77) {
		match = 1;
		address += 4;

		offset = (int8_t)get_memory_c(address + 1, 0);
	}


	if (match) {
		unsigned i, n;

		/* sanity check offset? should be positive. */

		n = get_memory_c(address++, 0);
		for (i = 0; i < n; ++i) {
			unsigned char c = get_memory_c(address++, 0);
			if (c & 0x80) return NULL;
			if (!isprint(c)) return NULL;
			buffer[i] = c;
		}
		buffer[i] = 0;
		return buffer;
	}

	return NULL;
}

word32 do_list(word32 address, int lines) {

	unsigned char buffer2[32];
	char buffer3[32];
	char buffer[32];

	const char *opcode_string;
	const char *comment;

	unsigned opcode;
	unsigned mode;
	unsigned operand;

	word32 pc;
	int i;
	int args;
	int n;

	while (lines--) {

		int bsize = 0;
		unsigned bank;
		pc = address;

		opcode = get_memory_c(address++, 0);
		mode = disasm_types[opcode];
		args = mode >> 8;

		buffer2[bsize++] = opcode;
		opcode_string = disasm_opcodes[opcode];
		comment = NULL;

		switch (args) {
			case 4:
				args = g_disasm_psr & 0x20 ? 1 : 2;
				break;
			case 5:
				args = g_disasm_psr & 0x10 ? 1 : 2;
				break;
		}
		operand = 0;
		switch(args) {
			case 1:
				operand = get_memory_c(address, 0);
				buffer2[bsize++] = operand;
				break;
			case 2:
				operand = get_memory16_c(address, 0);
				buffer2[bsize++] = operand;
				buffer2[bsize++] = operand >> 8;
				break;
			case 3:
				operand = get_memory24_c(address, 0);
				buffer2[bsize++] = operand;
				buffer2[bsize++] = operand >> 8;
				buffer2[bsize++] = operand >> 16;
				break;
		}
		address += args;
		buffer[0] = 0;

		uint32_t ea = 0;
		switch(mode & 0xff) {
			case ABS:
				sprintf(buffer, "$%04x", operand);
				break;
			case ABS_X:
				sprintf(buffer, "$%04x,x", operand);
				break;
			case ABS_Y:
				sprintf(buffer, "$%04x,y", operand);
				break;

			case DP:
				sprintf(buffer,"$%02x",operand);
				break;
			case DP_X:
				sprintf(buffer,"$%02x,x",operand);
				break;
			case DP_Y:
				sprintf(buffer,"$%02x,y",operand);
				break;

			case ABS_LONG:
				sprintf(buffer, "$%06x", operand);
				break;
			case ABS_LONG_X:
				sprintf(buffer, "$%06x,x", operand);
				break;
			case ABS_LONG_Y:
				sprintf(buffer, "$%06x,y", operand);
				break;


			case INDIR:
				sprintf(buffer,"($%0*x)", args * 2, operand );
				break;
			case INDIR_X:
				sprintf(buffer,"($%0*x,x)", args * 2, operand );
				break;
			case INDIR_Y:
				sprintf(buffer,"($%0*x),y", args * 2, operand );
				break;

			case INDIR_LONG:
				sprintf(buffer,"[$%0*x]", args * 2, operand );
				break;
			case INDIR_LONG_X:
				sprintf(buffer,"[$%0*x,x]", args * 2, operand );
				break;
			case INDIR_LONG_Y:
				sprintf(buffer,"[$%0*x],y", args * 2, operand );
				break;

			case SR:
				sprintf(buffer,"$%02x,s", operand );
				break;

			case SR_Y:
				sprintf(buffer,"($%02x,s),y", operand );
				break;

			case IMMEDIATE:
				sprintf(buffer,"#$%0*x",args * 2, operand);
				break;

			case INTERRUPT:
				sprintf(buffer,"$%02x",operand);
				break;

			case BLOCK:
				sprintf(buffer,"$%02x,$%02x",operand >> 8, operand & 0xff);
				break;

			case RELATIVE:
				ea = address;
				if (args == 1) ea += (int8_t)operand;
				else ea += (int16_t)operand;
				ea &= 0xffff;
				sprintf(buffer,"$%04x", ea);
				if (opcode == 0x62) ea = 0; /* per */
				else ea |= pc & 0xff0000;
				break;
		}

		if (!comment) {
			bank = pc >> 16;
			if (bank == 0xe0 || bank == 0xe1 || bank == 0x01 || bank == 0xff)
				comment = debug_tool_name(pc & 0xffff, bank, 1);
		}

		switch (opcode) {
			case 0xe2: /* sep */
				g_disasm_psr|= operand;
				break;
			case 0xc2: /* rep */
				g_disasm_psr &= ~operand;
				break;
			case 0xfb: /* xce */
				g_disasm_psr |= 0x0130;
				break;
			case 0xa2: /* ldx # */
				if (is_jsl_e10000(address)) {
					/* tool call ... */
					const char *name = debug_tool_name(operand, 0xe10000, 0);
					if (name) {
						opcode_string = name;
						buffer[0] = 0;
						for (i = 0; i < 4; ++i) {
							buffer2[bsize++] = get_memory_c(address++, 0);
						}
					}
				}
				break;
#if 0
			case 0xae: /* ldx ... */
			case 0xbe:
			case 0xa6:
			case 0xb6:
			case 0xfa: /* plx */
			case 0xaa: /* tax */
			case 0xba: /* tsx */
			case 0xbb: /* tyx */
			case 0xca: /* dex */
			case 0xe8: /* inx */
				break;
#endif
			case 0x22: /* jsl */
				ea = operand;
				if (operand == 0xe100a8) {
					/* inline GS/OS call? */
					unsigned num = get_memory16_c(address, 0);
					const char *name = debug_tool_name(num, operand, 0);
					if (name) {
						comment = NULL;
						opcode_string = name;
						unsigned parms = get_memory24_c(address + 2, 0);
						sprintf(buffer, "$%06x", parms);

						for (i = 0; i < 6; ++i) {
							buffer2[bsize++] = get_memory_c(address++, 0);
						}
					}
				}
				break;
			case 0x20: /* jsr */
				ea = (operand | (address & 0xff0000));
				if (ea == 0x00bf00) {
					unsigned num = get_memory_c(address, 0);
					const char *name = debug_tool_name(num, operand, 0);
					if (name) {
						opcode_string = name;
						unsigned parms = get_memory16_c(address + 1, 0);
						sprintf(buffer, "$%04x", parms);

						for (i = 0; i < 3; ++i) {
							buffer2[bsize++] = get_memory_c(address++, 0);
						}
					}
				}
				break;
			/* relative ops have ea set above */
			case 0x82: {

				const char *name = get_inline_debug_name(pc);
				/* start of an inline debug name? */
				if (name) {
					opcode_string = name;
					buffer[0] = 0;

					/* include the 0x77 71 magic bytes */
					for (i = 0; i < 2; ++i) {
						buffer2[bsize++] = get_memory_c(address++, 0);
					}
					address = ea;
					ea = 0;
				}
				break;
			}


		}

		if (opcode == 0xc2 || opcode == 0xe2) {
			if (!comment) {
				comment = buffer3;
				snprintf(buffer3, sizeof(buffer3), "e=%d m=%d x=%d",
					g_disasm_psr & 0x0100 ? 1 : 0,
					g_disasm_psr & 0x0020 ? 1 : 0,
					g_disasm_psr & 0x0010 ? 1 : 0
				);
			}
		}

		if (ea && !comment) {
			comment = get_inline_debug_name(ea);
		}


		/* 12/3456: 01 23 45      LDA #1     ; comment */ 
		n = printf("%02x/%04x:",
			pc >> 16, pc & 0xffff);

		for(i = 0; i < bsize; ++i) {
			n += printf(" %02x", buffer2[i]);
		}
		while (n < 40) { fputc(' ', stdout); ++n; }
		n += printf("%s %s", opcode_string, buffer);
		if (comment) {
			while (n < 65) { fputc(' ', stdout); ++n; }
			printf("; %s", comment);
		}

		fputc('\n', stdout);

	}
	return address;
}

#if 0
word32 next_pc(void) {
	/* return next pc, skipping subroutines,
	   accounting for inline calls, and branches
	 */
	word32 pc = engine.kpc;

	enum {
		C = 1 << 0,
		Z = 1 << 1,
		I = 1 << 2,
		D = 1 << 3,
		X = 1 << 4,
		M = 1 << 5,
		V = 1 << 6,
		N = 1 << 7,
		E = 1 << 8
	};

	unsigned opcode = get_memory_c(pc++, 0);
	unsigned operand = 0;

	unsigned mode = disasm_types[opcode];
	unsigned args = mode >> 8;

	switch (args) {
		case 4:
			args = engine.psr & M ? 1 : 2;
			break;
		case 5:
			args = engine.psr & X ? 1 : 2;
			break;
	}
	operand = 0;
	switch(args) {
		case 1:
			operand = get_memory_c(pc, 0);
			break;
		case 2:
			operand = get_memory16_c(pc, 0);
			break;
		case 3:
			operand = get_memory24_c(pc, 0);
			break;
	}
	pc += args;

	switch (opcode) {
		case 0x20:
			if ((pc & 0xff0000) == 0 && operand == 0xbf00)
				return pc + 3;
			break;
		case 0x22:
			if (operand == 0xe100a8)
				return pc + 6;
			break;

		case 0x82: /* brl */
			operand += pc & 0xffff;
			return (pc & 0xff0000) | operand;
			break;
		case 0x80: /* bra */
			operand = (pc + (int8_t)operand) & 0xffff;
			return (pc & 0xff0000) | operand;
			break;

		case 0x90: /* bcc */
			operand = (pc + (int8_t)operand) & 0xffff;
			if (~engine.psr & C)
				return (pc & 0xff0000) | operand;
			break;
		case 0xb0: /* bcc */
			operand = (pc + (int8_t)operand) & 0xffff;
			if (engine.psr & C)
				return (pc & 0xff0000) | operand;
			break;

		case 0x10: /* bpl */
			operand = (pc + (int8_t)operand) & 0xffff;
			if (~engine.psr & N)
				return (pc & 0xff0000) | operand;
			break;
		case 0x30: /* bmi */
			operand = (pc + (int8_t)operand) & 0xffff;
			if (engine.psr & N)
				return (pc & 0xff0000) | operand;
			break;

		case 0x50: /* bvc */
			operand = (pc + (int8_t)operand) & 0xffff;
			if (~engine.psr & V)
				return (pc & 0xff0000) | operand;
			break;
		case 0x70: /* bvs */
			operand = (pc + (int8_t)operand) & 0xffff;
			if (engine.psr & V)
				return (pc & 0xff0000) | operand;
			break;

		case 0xd0: /* bvc */
			operand = (pc + (int8_t)operand) & 0xffff;
			if (~engine.psr & Z)
				return (pc & 0xff0000) | operand;
			break;
		case 0xf0: /* beq */
			operand = (pc + (int8_t)operand) & 0xffff;
			if (engine.psr & Z)
				return (pc & 0xff0000) | operand;
			break;

	}


	return 0;
}
#endif

/*
 * todo -- 
 * should use tmp breakpoint instead of g_stepping?
 * don't want to step into an interrupt, for example.
 * also, step should steps over gs/os, toolbox calls
 * (gsbug has protected memory ranges)
 */
int next_pc(void) {

	word32 pc = engine.kpc;
	unsigned opcode = get_memory_c(pc++, 0);
	unsigned operand = 0;

	switch (opcode) {
		case 0x20: /* jsr abs */
			operand = get_memory16_c(pc, 0);
			pc += 2;
			if ((pc & 0xff0000) == 0 && operand == 0xbf00)
				pc += 3;
			return pc;
			break;
		case 0xfc: /* jsr (abs,x) */
			return pc + 2;
			break;
		case 0x22: /* jsl */
			operand = get_memory24_c(pc, 0);
			pc += 3;
			if (operand == 0xe100a8)
				pc += 6;
			return pc;
			break;
		case 0x00: /* brk arg */
		case 0x02: /* cop arg */
			return pc + 2;
			break;
	}

	return -1;
}


enum {
	REG_A,
	REG_B,
	REG_D,
	REG_E,
	REG_K,
	REG_MX,
	REG_P,
	REG_PC,
	REG_S,
	REG_X,
	REG_Y,
};

static word32 to_hex(const char *iter, const char *end) {
	word32 rv = 0;
	while(iter != end) {
		char c = *iter++;
		rv <<= 4;
		if (isdigit(c)) rv |= c - '0';
		else rv |= (c | 0x20) - 'a' + 10;
	}
	return rv;
}


#line 999 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"


static int do_assign(const char *cp, int reg) {

	word32 addr = 0;
	int has_bank = 0;
	const char *YYCURSOR = cp;
	const char *YYMARKER = NULL;
	const char *YYCTXMARKER = NULL;

	
#line 1008 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
{
	char yych;
	yych = *YYCURSOR;
	switch (yych) {
	case '%':	goto yy4;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy5;
	default:	goto yy2;
	}
yy2:
	++YYCURSOR;
yy3:
#line 1011 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return -1; }
#line 1043 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy4:
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '0':
	case '1':	goto yy6;
	case 'a':	goto yy8;
	case 'b':	goto yy9;
	case 'd':	goto yy10;
	case 'e':	goto yy11;
	case 'k':	goto yy12;
	case 'p':	goto yy13;
	case 's':	goto yy14;
	case 'x':	goto yy15;
	case 'y':	goto yy16;
	default:	goto yy3;
	}
yy5:
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy17;
	default:	goto yy3;
	}
yy6:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':	goto yy18;
	default:	goto yy7;
	}
yy7:
	YYCURSOR = YYMARKER;
	goto yy3;
yy8:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy19;
	goto yy7;
yy9:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy21;
	goto yy7;
yy10:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy23;
	goto yy7;
yy11:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy25;
	goto yy7;
yy12:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy27;
	goto yy7;
yy13:
	yych = *++YYCURSOR;
	switch (yych) {
	case 0x00:	goto yy29;
	case 'c':	goto yy31;
	default:	goto yy7;
	}
yy14:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy32;
	goto yy7;
yy15:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy34;
	goto yy7;
yy16:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy36;
	goto yy7;
yy17:
	yych = *++YYCURSOR;
	switch (yych) {
	case '/':	goto yy38;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy39;
	default:	goto yy7;
	}
yy18:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy40;
	goto yy7;
yy19:
	++YYCURSOR;
#line 1039 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = engine.acc;
			goto next;
		}
#line 1175 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy21:
	++YYCURSOR;
#line 1059 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = engine.dbank;
			goto next;
		}
#line 1183 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy23:
	++YYCURSOR;
#line 1051 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = engine.direct;
			goto next;
		}
#line 1191 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy25:
	++YYCURSOR;
#line 1071 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = engine.psr >> 8;
			goto next;
		}
#line 1199 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy27:
	++YYCURSOR;
#line 1063 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = engine.kpc >> 16;
			goto next;
		}
#line 1207 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy29:
	++YYCURSOR;
#line 1067 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = engine.psr & 0xff;
			goto next;
		}
#line 1215 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy31:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy42;
	goto yy7;
yy32:
	++YYCURSOR;
#line 1055 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = engine.stack;
			goto next;
		}
#line 1227 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy34:
	++YYCURSOR;
#line 1043 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = engine.xreg;
			goto next;
		}
#line 1235 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy36:
	++YYCURSOR;
#line 1047 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = engine.yreg;
			goto next;
		}
#line 1243 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy38:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy44;
	default:	goto yy7;
	}
yy39:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy45;
	default:	goto yy7;
	}
yy40:
	++YYCURSOR;
#line 1028 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			if (reg != REG_MX) return -1;
			if (cp[1] == '1') addr |= 0x20;
			if (cp[2] == '1') addr |= 0x10;
			goto next;
		}
#line 1307 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy42:
	++YYCURSOR;
#line 1034 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = engine.kpc;
			has_bank = 1;
			goto next;
		}
#line 1316 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy44:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy46;
	default:	goto yy7;
	}
yy45:
	yych = *++YYCURSOR;
	switch (yych) {
	case 0x00:	goto yy47;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy49;
	default:	goto yy7;
	}
yy46:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy50;
	default:	goto yy7;
	}
yy47:
	++YYCURSOR;
#line 1023 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = to_hex(cp, cp + 4);
			has_bank = 0;
			goto next;
		}
#line 1407 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy49:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy51;
	default:	goto yy7;
	}
yy50:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy52;
	default:	goto yy7;
	}
yy51:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy53;
	goto yy7;
yy52:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy55;
	goto yy7;
yy53:
	++YYCURSOR;
#line 1012 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = to_hex(cp, cp + 6);
			has_bank = 1;
			goto next;
		}
#line 1478 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy55:
	++YYCURSOR;
#line 1017 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = to_hex(cp, cp + 2) << 16;
			addr |= to_hex(cp + 3, cp + 7);
			has_bank = 1;
			goto next;
		}
#line 1488 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
}
#line 1075 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"


next:

	if (has_bank && reg != REG_PC) return -1;

	switch(reg) {
		case REG_A: engine.acc = addr; break;
		case REG_X: engine.xreg = addr; break;
		case REG_Y: engine.yreg = addr; break;
		case REG_D: engine.direct = addr; break;
		case REG_S: engine.stack = addr; break;
		case REG_B: engine.dbank = addr & 0xff; break;

		case REG_E:
			engine.psr &= 0xff;
			if (addr) engine.psr |= 0x0100;
			break;

		case REG_K:
			addr = (addr & 0xff) << 16;
			engine.kpc = (engine.kpc & 0xffff) | addr;
			break;

		case REG_PC:
			if (!has_bank) addr |= (engine.kpc & 0xff0000);
			engine.kpc = addr;
			break;

		case REG_P:
			engine.psr &= ~0xff;
			engine.psr |= (addr & 0xff);
			break;

		case REG_MX:
			/* only 00, 10, 20, 30 are legal values */
			if ((addr | 0x30) != 0x30) return -1;
			engine.psr &= ~0x30;
			engine.psr |= addr;
			break;


	}

	/* fixup registers */
	if (engine.psr & 0x0100) {
		engine.psr |= 0x30;
		engine.stack = (engine.stack & 0xff) | 0x0100;
	}
	if (engine.psr & 0x10) {
		engine.xreg &= 0xff;
		engine.yreg &= 0xff;
	}
	return 0;
}

static int do_setting(const char *cp, int value) {

	const char *YYCURSOR = cp;
	const char *YYMARKER = NULL;
	const char *YYCTXMARKER = NULL;
	unsigned psr_bits = 0;


	/* TODO - nl uses 'a' to track sep/rep/xce */

	
#line 1558 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
{
	char yych;
	yych = *YYCURSOR;
	switch (yych) {
	case 'b':	goto yy61;
	case 'c':	goto yy62;
	case 'e':	goto yy63;
	case 'm':	goto yy64;
	case 'x':	goto yy65;
	default:	goto yy59;
	}
yy59:
	++YYCURSOR;
yy60:
#line 1142 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			fputs("invalid setting\n", stderr); 
			return -1;
		}
#line 1578 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy61:
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case 'r':	goto yy66;
	default:	goto yy60;
	}
yy62:
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case 'o':	goto yy68;
	default:	goto yy60;
	}
yy63:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy69;
	goto yy60;
yy64:
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case 0x00:	goto yy71;
	case 'x':	goto yy73;
	default:	goto yy60;
	}
yy65:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy74;
	goto yy60;
yy66:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'k':	goto yy76;
	default:	goto yy67;
	}
yy67:
	YYCURSOR = YYMARKER;
	goto yy60;
yy68:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'p':	goto yy77;
	default:	goto yy67;
	}
yy69:
	++YYCURSOR;
#line 1159 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ psr_bits = 0x0100; goto set_psr; }
#line 1625 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy71:
	++YYCURSOR;
#line 1160 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ psr_bits = 0x0020; goto set_psr; }
#line 1630 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy73:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy78;
	goto yy67;
yy74:
	++YYCURSOR;
#line 1161 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ psr_bits = 0x0010; goto set_psr; }
#line 1639 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy76:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy80;
	goto yy67;
yy77:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy82;
	goto yy67;
yy78:
	++YYCURSOR;
#line 1162 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ psr_bits = 0x0030; goto set_psr; }
#line 1652 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy80:
	++YYCURSOR;
#line 1146 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			engine.flags &= ~FLAG_WANT_BRK;
			if (value) engine.flags |= FLAG_WANT_BRK;
			printf("brk intercept %s\n", value ? "on" : "off");
			return 0;
		}
#line 1662 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy82:
	++YYCURSOR;
#line 1152 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			engine.flags &= ~FLAG_WANT_COP;
			if (value) engine.flags |= FLAG_WANT_COP;
			printf("cop intercept %s\n", value ? "on" : "off");
			return 0;			
		}
#line 1672 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
}
#line 1163 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"


set_psr:
	if (value) g_disasm_psr |= psr_bits;
	else g_disasm_psr &= ~psr_bits;
	if (g_disasm_psr & 0x0100) g_disasm_psr = 0x0130;
	printf("disasm psr %03x\n", g_disasm_psr);
	return 0;
}

#if 0
static int do_brk_cop(const char *cp, int which) {
	/* brk=1 / brk=0 */

	const char *YYCURSOR = cp;
	int value = 0;

	
#line 1693 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
{
	char yych;
	yych = *YYCURSOR;
	switch (yych) {
	case '0':
	case '1':	goto yy88;
	default:	goto yy86;
	}
yy86:
	++YYCURSOR;
yy87:
#line 1185 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return -1; }
#line 1707 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy88:
	yych = *++YYCURSOR;
	if (yych >= 0x01) goto yy87;
	++YYCURSOR;
#line 1181 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			value = *cp - '0';
			goto next;
		}
#line 1717 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
}
#line 1186 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"

next:

	switch(which) {
		case 0x00:
			engine.flags &= ~FLAG_WANT_BRK;
			if (value) engine.flags |= FLAG_WANT_BRK;
			printf("brk intercept %s\n\n", value ? "on" : "off");
			break;
		case 0x02:
			engine.flags &= ~FLAG_WANT_COP;
			if (value) engine.flags |= FLAG_WANT_COP;
			printf("cop intercept %s\n\n", value ? "on" : "off");
			break;
	}
	return 0;
}
#endif


static word32 do_mem_assign(word32 addr, const char *cp) {
	/* "string" -> pokes ASCII chars */
	/* 'string' -> pokes ASCII chars | 0x80 */
	/* xx -> pokes hex byte */

	const char *YYCURSOR = cp;
	const char *YYMARKER = NULL;
	const char *YYCTXMARKER = NULL;

	for(;;) {
		const char *start = YYCURSOR;
		
#line 1752 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
{
	char yych;
	yych = *YYCURSOR;
	switch (yych) {
	case 0x00:	goto yy93;
	case '\t':
	case ' ':	goto yy97;
	case '"':	goto yy99;
	case '\'':	goto yy100;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy101;
	default:	goto yy95;
	}
yy93:
	++YYCURSOR;
#line 1218 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return addr; }
#line 1790 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy95:
	++YYCURSOR;
yy96:
#line 1220 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
				fputs("Invalid data\n", stderr);
				return addr;
			}
#line 1799 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy97:
	++YYCURSOR;
#line 1219 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ continue; }
#line 1804 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy99:
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 0x00) goto yy96;
	goto yy103;
yy100:
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 0x00) goto yy96;
	goto yy108;
yy101:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy111;
	default:	goto yy96;
	}
yy102:
	yych = *++YYCURSOR;
yy103:
	switch (yych) {
	case 0x00:	goto yy104;
	case '"':	goto yy105;
	default:	goto yy102;
	}
yy104:
	YYCURSOR = YYMARKER;
	goto yy96;
yy105:
	++YYCURSOR;
#line 1228 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
				for(++start; start < YYCURSOR -1; ++start) {
					set_memory_c(addr++, *start, 0);				
				}
				continue;
			}
#line 1860 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy107:
	yych = *++YYCURSOR;
yy108:
	switch (yych) {
	case 0x00:	goto yy104;
	case '\'':	goto yy109;
	default:	goto yy107;
	}
yy109:
	++YYCURSOR;
#line 1234 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
				for(++start; start < YYCURSOR -1; ++start) {
					set_memory_c(addr++, *start | 0x80, 0);				
				}
				continue;
			}
#line 1878 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy111:
	++YYCURSOR;
#line 1224 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
				set_memory_c(addr++, to_hex(start, YYCURSOR), 0);
				continue;
			}
#line 1886 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
}
#line 1241 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"

	}
}


static int addr_cmp(const void *a, const void *b) {
	word32 aa = *(const word32 *)a;
	word32 bb = *(const word32 *)b;

	return (int)aa - (int)bb;
}



void show_bp(int type) {
	int i;
	word32 addr;
	word32 *breakpoints;
	int num_breakpoints;

	switch(type) {
		case 'B':
			breakpoints = g_bp_breakpoints;
			num_breakpoints = g_num_bp_breakpoints;
			break;
		case 'M':
			breakpoints = g_mp_breakpoints;
			num_breakpoints = g_num_mp_breakpoints;
			break;

		case 'T':
			breakpoints = g_tp_breakpoints;
			num_breakpoints = g_num_tp_breakpoints;
			break;


		default:
			fputs("Invalid breakpoint type\n", stderr);
			return;
	}

	fputs("Breakpoints:\n", stdout);
	for (i = 0; i < num_breakpoints; ++i) {
		addr = breakpoints[i];
		printf("%02x/%04x\n", addr >> 16, addr & 0xffff);
	}
}

int set_bp(int type, word32 addr) {
	int i;

	word32 *breakpoints;
	int num_breakpoints;

	switch(type) {
		case 'B':
			breakpoints = g_bp_breakpoints;
			num_breakpoints = g_num_bp_breakpoints;
			break;
		case 'M':
			breakpoints = g_mp_breakpoints;
			num_breakpoints = g_num_mp_breakpoints;
			break;
		case 'T':
			breakpoints = g_tp_breakpoints;
			num_breakpoints = g_num_tp_breakpoints;
			break;

		default:
			fputs("Invalid breakpoint type\n", stderr);
			return 0;
	}

	for (i = 0; i < num_breakpoints; ++i) {
		if (breakpoints[i] == addr) break;
	}

	if (i < num_breakpoints) return 1; /* already set */
	if (num_breakpoints == MAX_BREAK_POINTS) {
		printf("Too many breakpoints.\n");
		return 0;
	}
	breakpoints[num_breakpoints++] = addr;

	switch(type) {
		case 'B': g_num_bp_breakpoints = num_breakpoints; break;
		case 'M': g_num_mp_breakpoints = num_breakpoints; break;
		case 'T': g_num_tp_breakpoints = num_breakpoints; break;
	}

	qsort(breakpoints, num_breakpoints, sizeof(word32), addr_cmp);
	fixup_brks();
	return 1;
}

/* returns 1 if address deleted */
int delete_bp(int type, word32 addr) {
	int i;

	word32 *breakpoints;
	int num_breakpoints;

	switch(type) {
		case 'B':
			breakpoints = g_bp_breakpoints;
			num_breakpoints = g_num_bp_breakpoints;
			break;
		case 'M':
			breakpoints = g_mp_breakpoints;
			num_breakpoints = g_num_mp_breakpoints;
			break;
		case 'T':
			breakpoints = g_tp_breakpoints;
			num_breakpoints = g_num_tp_breakpoints;
			break;

		default:
			fputs("Invalid breakpoint type\n", stderr);
			return 0;
	}

	for (i = 0; i < num_breakpoints; ++i) {
		if (breakpoints[i] == addr) break;
	}

	if (i == num_breakpoints) return 0; /* not set */
	breakpoints[i] = 0;
	breakpoints[i] = breakpoints[--num_breakpoints]; 

	switch(type) {
		case 'B': g_num_bp_breakpoints = num_breakpoints; break;
		case 'M': g_num_mp_breakpoints = num_breakpoints; break;
		case 'T': g_num_tp_breakpoints = num_breakpoints; break;
	}

	qsort(breakpoints, num_breakpoints, sizeof(word32), addr_cmp);
	fixup_brks();
	return 1;
}


static void do_help(void) {

	fputs(
		"  *                       Print registers\n"
		"  reg=value               Assign register (a,x,y,etc)\n"
		"  reset                   Reset computer\n"
		"  quit                    Exit debugger\n"
		"  s                       Single step\n"
		"  g                       Go\n"
		"  bp                      List PC breakpoints\n"
		"  mp                      List memory breakpoints\n"
		"\n"
		"  [address];l             List\n"
		"  [address];h             Hexdump\n"
		"  [address];bp            Set PC breakpoint\n"
		"  [address];bp-           Remove PC breakpoint\n"
		"  [address];mp            Set memory breakpoint\n"
		"  [address];mp-           Remove memory breakpoint\n"
		"  [address]\\temp name    Display template\n"
		"\n"
		"\n"
		"Address = 12/3456, 123456, or 1234\n"
		"Register = %%a, %%x, %%y, %%pc, etc\n",
		stdout);
}



/* return -1 on error, 0 on success, 1 if debug shell should exit. */
static int parse_command(const char *cp) {


	/* TODO:
		! -> mini assembler mode.
	 */

	const char *YYCURSOR = cp;
	const char *YYMARKER = NULL;
	const char *YYCTXMARKER = NULL;

	int addr = 0;
	int has_bank = 0;
	int has_addr = 0;

	while (*cp == ' ') ++cp;

	
#line 2077 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
{
	char yych;
	unsigned int yyaccept = 0;
	yych = *YYCURSOR;
	switch (yych) {
	case '!':	goto yy117;
	case '%':	goto yy118;
	case '*':	goto yy119;
	case '0':	goto yy120;
	case '1':	goto yy122;
	case '2':
	case '3':
	case '4':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'c':
	case 'd':
	case 'f':	goto yy123;
	case '5':	goto yy124;
	case '?':	goto yy125;
	case 'b':	goto yy126;
	case 'e':	goto yy127;
	case 'h':	goto yy128;
	case 'm':	goto yy129;
	case 'q':	goto yy130;
	case 'r':	goto yy131;
	default:	goto yy115;
	}
yy115:
	++YYCURSOR;
yy116:
#line 1432 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ --YYCURSOR; if (cp == YYCURSOR) goto command; return -1; }
#line 2120 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy117:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case 0x00:	goto yy132;
	case '!':	goto yy134;
	default:	goto yy116;
	}
yy118:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case 'a':	goto yy136;
	case 'b':	goto yy138;
	case 'd':	goto yy139;
	case 'e':	goto yy141;
	case 'k':	goto yy142;
	case 'm':	goto yy143;
	case 'p':	goto yy144;
	case 's':	goto yy145;
	case 'x':	goto yy147;
	case 'y':	goto yy149;
	default:	goto yy116;
	}
yy119:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy151;
	goto yy116;
yy120:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy153;
	case '>':	goto yy154;
	default:	goto yy121;
	}
yy121:
#line 1567 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = to_hex(cp, YYCURSOR);
			has_bank = 0;
			has_addr = 1;
			goto indir;
		}
#line 2185 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy122:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy153;
	case '>':	goto yy156;
	default:	goto yy121;
	}
yy123:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy153;
	default:	goto yy121;
	}
yy124:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy153;
	case 's':	goto yy158;
	default:	goto yy121;
	}
yy125:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy159;
	goto yy116;
yy126:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy153;
	case 'p':	goto yy161;
	case 'y':	goto yy162;
	default:	goto yy121;
	}
yy127:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy153;
	case 'x':	goto yy163;
	default:	goto yy121;
	}
yy128:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case 'e':	goto yy164;
	default:	goto yy116;
	}
yy129:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case 'p':	goto yy165;
	default:	goto yy116;
	}
yy130:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case 0x00:	goto yy166;
	case 'u':	goto yy163;
	default:	goto yy116;
	}
yy131:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case 'e':	goto yy168;
	default:	goto yy116;
	}
yy132:
	++YYCURSOR;
#line 1448 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			extern uint32_t mini_asm_shell(uint32_t addr);
			g_prev_address = mini_asm_shell(g_prev_address);
			return 0;
		}
#line 2370 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy134:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy169;
yy135:
	YYCURSOR = YYMARKER;
	switch (yyaccept) {
	case 0:
		goto yy116;
	case 1:
		goto yy121;
	case 2:
		goto yy146;
	default:
		goto yy185;
	}
yy136:
	yych = *++YYCURSOR;
	switch (yych) {
	case '=':	goto yy171;
	default:	goto yy137;
	}
yy137:
#line 1521 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = engine.acc;
			has_addr = 1;
			has_bank = 0;
			goto indir;
		}
#line 2400 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy138:
	yych = *++YYCURSOR;
	switch (yych) {
	case '=':	goto yy173;
	default:	goto yy135;
	}
yy139:
	yych = *++YYCURSOR;
	switch (yych) {
	case '=':	goto yy175;
	default:	goto yy140;
	}
yy140:
#line 1545 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = engine.direct;
			has_addr = 1;
			has_bank = 1;
			goto indir;
		}
#line 2421 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy141:
	yych = *++YYCURSOR;
	switch (yych) {
	case '=':	goto yy177;
	default:	goto yy135;
	}
yy142:
	yych = *++YYCURSOR;
	switch (yych) {
	case '=':	goto yy179;
	default:	goto yy135;
	}
yy143:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'x':	goto yy181;
	default:	goto yy135;
	}
yy144:
	yych = *++YYCURSOR;
	switch (yych) {
	case '=':	goto yy182;
	case 'c':	goto yy184;
	default:	goto yy135;
	}
yy145:
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '+':	goto yy186;
	case '-':	goto yy187;
	default:	goto yy146;
	}
yy146:
#line 1539 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = engine.stack;
			has_addr = 1;
			has_bank = 1;
			goto indir;
		}
#line 2463 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy147:
	yych = *++YYCURSOR;
	switch (yych) {
	case '=':	goto yy188;
	default:	goto yy148;
	}
yy148:
#line 1527 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = engine.xreg;
			has_addr = 1;
			has_bank = 0;
			goto indir;
		}
#line 2478 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy149:
	yych = *++YYCURSOR;
	switch (yych) {
	case '=':	goto yy190;
	default:	goto yy150;
	}
yy150:
#line 1533 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = engine.yreg;
			has_addr = 1;
			has_bank = 0;
			goto indir;
		}
#line 2493 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy151:
	++YYCURSOR;
#line 1437 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ show_regs(); return 0; }
#line 2498 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy153:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '/':	goto yy192;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy193;
	default:	goto yy121;
	}
yy154:
	++YYCURSOR;
#line 1454 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return do_setting(YYCURSOR, 0); }
#line 2532 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy156:
	++YYCURSOR;
#line 1455 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return do_setting(YYCURSOR, 1); }
#line 2537 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy158:
	yych = *++YYCURSOR;
	switch (yych) {
	case '=':	goto yy194;
	default:	goto yy135;
	}
yy159:
	++YYCURSOR;
#line 1441 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ do_help(); return 0; }
#line 2548 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy161:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy196;
	goto yy135;
yy162:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'e':	goto yy198;
	default:	goto yy135;
	}
yy163:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'i':	goto yy199;
	default:	goto yy135;
	}
yy164:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'l':	goto yy200;
	default:	goto yy135;
	}
yy165:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy201;
	goto yy135;
yy166:
	++YYCURSOR;
#line 1439 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return 'q'; }
#line 2579 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy168:
	yych = *++YYCURSOR;
	switch (yych) {
	case 's':	goto yy203;
	default:	goto yy135;
	}
yy169:
	++YYCURSOR;
#line 1443 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			extern uint32_t sweet16_asm_shell(uint32_t addr);
			g_prev_address = sweet16_asm_shell(g_prev_address);
			return 0;
		}
#line 2594 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy171:
	++YYCURSOR;
#line 1502 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return do_assign(YYCURSOR, REG_A); }
#line 2599 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy173:
	++YYCURSOR;
#line 1509 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return do_assign(YYCURSOR, REG_B); }
#line 2604 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy175:
	++YYCURSOR;
#line 1505 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return do_assign(YYCURSOR, REG_D); }
#line 2609 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy177:
	++YYCURSOR;
#line 1506 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return do_assign(YYCURSOR, REG_E); }
#line 2614 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy179:
	++YYCURSOR;
#line 1508 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return do_assign(YYCURSOR, REG_K); }
#line 2619 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy181:
	yych = *++YYCURSOR;
	switch (yych) {
	case '=':	goto yy204;
	default:	goto yy135;
	}
yy182:
	++YYCURSOR;
#line 1510 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return do_assign(YYCURSOR, REG_P); }
#line 2630 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy184:
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '+':	goto yy206;
	case '=':	goto yy207;
	default:	goto yy185;
	}
yy185:
#line 1515 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = engine.kpc;
			has_addr = 1;
			has_bank = 1;
			goto indir;
		}
#line 2647 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy186:
	yych = *++YYCURSOR;
	switch (yych) {
	case '+':	goto yy209;
	default:	goto yy135;
	}
yy187:
	yych = *++YYCURSOR;
	switch (yych) {
	case '-':	goto yy210;
	default:	goto yy135;
	}
yy188:
	++YYCURSOR;
#line 1503 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return do_assign(YYCURSOR, REG_X); }
#line 2664 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy190:
	++YYCURSOR;
#line 1504 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return do_assign(YYCURSOR, REG_Y); }
#line 2669 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy192:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy211;
	default:	goto yy135;
	}
yy193:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy212;
	default:	goto yy121;
	}
yy194:
	++YYCURSOR;
#line 1507 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return do_assign(YYCURSOR, REG_S); }
#line 2728 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy196:
	++YYCURSOR;
#line 1434 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ show_bp('B'); return 0; }
#line 2733 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy198:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy166;
	goto yy135;
yy199:
	yych = *++YYCURSOR;
	switch (yych) {
	case 't':	goto yy198;
	default:	goto yy135;
	}
yy200:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'p':	goto yy213;
	default:	goto yy135;
	}
yy201:
	++YYCURSOR;
#line 1435 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ show_bp('M'); return 0; }
#line 2754 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy203:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'e':	goto yy214;
	default:	goto yy135;
	}
yy204:
	++YYCURSOR;
#line 1512 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return do_assign(YYCURSOR, REG_MX); }
#line 2765 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy206:
	yych = *++YYCURSOR;
	switch (yych) {
	case '+':	goto yy215;
	default:	goto yy135;
	}
yy207:
	++YYCURSOR;
#line 1511 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return do_assign(YYCURSOR, REG_PC); }
#line 2776 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy209:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy216;
	goto yy135;
yy210:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy218;
	goto yy135;
yy211:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy220;
	default:	goto yy135;
	}
yy212:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy221;
	default:	goto yy121;
	}
yy213:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy159;
	goto yy135;
yy214:
	yych = *++YYCURSOR;
	switch (yych) {
	case 't':	goto yy222;
	default:	goto yy135;
	}
yy215:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy223;
	goto yy135;
yy216:
	++YYCURSOR;
#line 1480 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			unsigned tmp = engine.stack + 1;
			if (engine.psr & 0x0100) {
				tmp &= 0xff;
				tmp |= 0x0100;
			} else {
				tmp &= 0xffff;
			}
			engine.stack = tmp;
		}
#line 2867 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy218:
	++YYCURSOR;
#line 1491 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			unsigned tmp = engine.stack + 1;
			if (engine.psr & 0x0100) {
				tmp &= 0xff;
				tmp |= 0x0100;
			} else {
				tmp &= 0xffff;
			}
			engine.stack = tmp;
		}
#line 2881 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy220:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy225;
	default:	goto yy135;
	}
yy221:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy226;
	default:	goto yy135;
	}
yy222:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy228;
	goto yy135;
yy223:
	++YYCURSOR;
#line 1459 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			/* todo */
			unsigned opcode = get_memory_c(engine.kpc, 0);
			unsigned mode = disasm_types[opcode];
			unsigned args = mode >> 8;
			word32 tmp;

			switch (args) {
				case 4:
					args = engine.psr & 0x20 ? 1 : 2;
					break;
				case 5:
					args = engine.psr & 0x10 ? 1 : 2;
					break;
			}
			tmp = engine.kpc + 1 + args;
			tmp &= 0xffff;
			engine.kpc = (engine.kpc & 0xff0000) | tmp;
			return 0;	
		}
#line 2963 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy225:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy230;
	default:	goto yy135;
	}
yy226:
	++YYCURSOR;
#line 1554 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = to_hex(cp, cp + 6);
			has_bank = 1;
			has_addr = 1;
			goto indir;
		}
#line 3000 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy228:
	++YYCURSOR;
#line 1440 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ do_reset(); return 0; }
#line 3005 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy230:
	++YYCURSOR;
#line 1560 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			addr = to_hex(cp, cp + 2) << 16;
			addr |= to_hex(cp + 3, cp + 7);
			has_bank = 1;
			has_addr = 1;
			goto indir;
		}
#line 3016 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
}
#line 1573 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"

indir:
	cp = YYCURSOR;
	/* only gets here if address specified */
	for(;;) {
	
#line 3025 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
{
	char yych;
	yych = *YYCURSOR;
	switch (yych) {
	case '@':	goto yy235;
	case '^':	goto yy237;
	default:	goto yy234;
	}
yy234:
#line 1579 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ break; }
#line 3037 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy235:
	++YYCURSOR;
#line 1587 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			/* 2-byte indirection */
			/* 3-byte indirection */
			if (!has_bank) addr = (g_prev_address & 0xff0000) | addr;
			word32 b = addr & 0xff0000;
			addr = get_memory16_c(addr, 0) | b;
			has_bank = 1;
			continue; 
		}
#line 3050 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy237:
	++YYCURSOR;
#line 1580 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			/* 3-byte indirection */
			if (!has_bank) addr = (g_prev_address & 0xff0000) | addr;
			addr = get_memory24_c(addr, 0);
			has_bank = 1;
			continue; 
		}
#line 3061 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
}
#line 1596 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"

	}

command:
	if (!has_bank) {
		addr |= (g_prev_address & 0xff0000);
	}
	if (!has_addr) {
		addr = g_prev_address;
	}

	cp = YYCURSOR;
	
#line 3077 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
{
	char yych;
	yych = *YYCURSOR;
	switch (yych) {
	case ':':	goto yy243;
	case ';':	goto yy245;
	case '\\':	goto yy246;
	case 'g':	goto yy247;
	case 'h':	goto yy248;
	case 'i':	goto yy249;
	case 'l':	goto yy250;
	case 'n':	goto yy251;
	case 's':	goto yy252;
	case 't':	goto yy253;
	case 'w':	goto yy255;
	default:	goto yy241;
	}
yy241:
	++YYCURSOR;
yy242:
#line 1609 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{ return  -1; }
#line 3100 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy243:
	++YYCURSOR;
#line 1611 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			g_prev_address = do_mem_assign(addr, YYCURSOR);
			return 0;
		}
#line 3108 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy245:
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case 'b':	goto yy256;
	case 'h':	goto yy258;
	case 'l':	goto yy259;
	case 'm':	goto yy260;
	case 's':	goto yy261;
	default:	goto yy242;
	}
yy246:
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case 't':	goto yy262;
	default:	goto yy242;
	}
yy247:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy263;
	goto yy242;
yy248:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy265;
	goto yy242;
yy249:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy267;
	goto yy242;
yy250:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy269;
	goto yy242;
yy251:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy271;
	goto yy242;
yy252:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy273;
	goto yy242;
yy253:
	++YYCURSOR;
#line 1720 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			g_prev_address = tool_lookup(addr & 0xffff);
			return 0;
		}
#line 3156 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy255:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy275;
	goto yy242;
yy256:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'p':	goto yy277;
	default:	goto yy257;
	}
yy257:
	YYCURSOR = YYMARKER;
	goto yy242;
yy258:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy278;
	goto yy257;
yy259:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy269;
	goto yy257;
yy260:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'p':	goto yy280;
	default:	goto yy257;
	}
yy261:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy281;
	goto yy257;
yy262:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'e':	goto yy283;
	default:	goto yy257;
	}
yy263:
	++YYCURSOR;
#line 1640 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			/* GO! */
			if (has_addr) {
				engine.kpc = addr;
			}
			g_stepping = 0;
			return 1;
		}
#line 3205 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy265:
	++YYCURSOR;
#line 1702 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			g_prev_address = addr;
			do_handle(addr, 'h');
			return 0;
		}
#line 3214 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy267:
	++YYCURSOR;
#line 1708 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			g_prev_address = addr;
			do_handle(addr, 'i');
			return 0;
		}
#line 3223 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy269:
	++YYCURSOR;
#line 1616 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			g_prev_address = do_list(addr, 20);
			return 0;
		}
#line 3231 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy271:
	++YYCURSOR;
#line 1659 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			/* next.  steps OVER jsr/jsl */

			if (has_addr) {
				engine.kpc = addr;
			}
			int tmp = next_pc();
			if (tmp < 0) {
				g_stepping = 1;
			} else {
				g_stepping = 0;
				set_bp('T', tmp);
			}

			clear_prev_line();
			return 1;
		}
#line 3252 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy273:
	++YYCURSOR;
#line 1648 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			/* step */
			if (has_addr) {
				engine.kpc = addr;
			}
			g_stepping = 1;

			clear_prev_line();
			return 1;
		}
#line 3266 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy275:
	++YYCURSOR;
#line 1714 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			g_prev_address = addr;
			do_handle(addr, 'w');
			return 0;
		}
#line 3275 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy277:
	yych = *++YYCURSOR;
	switch (yych) {
	case 0x00:	goto yy284;
	case '+':
	case '-':	goto yy286;
	default:	goto yy257;
	}
yy278:
	++YYCURSOR;
#line 1620 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			g_prev_address = do_hexdump(addr, 20);
			return 0;
		}
#line 3291 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy280:
	yych = *++YYCURSOR;
	switch (yych) {
	case 0x00:	goto yy287;
	case '+':
	case '-':	goto yy289;
	default:	goto yy257;
	}
yy281:
	++YYCURSOR;
#line 1625 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			/* print the stack */
			word32 bank;
			if (!has_addr) {
				addr = g_prev_stack_address;
				bank = g_prev_stack_bank;
			}
			if (has_bank) {
				bank = addr & 0xff0000;
				addr &= 0xffff;
			}
			g_prev_stack_address = do_stack(addr,bank);
			return 0;
		}
#line 3317 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy283:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'm':	goto yy290;
	default:	goto yy257;
	}
yy284:
	++YYCURSOR;
#line 1677 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			char plus = cp[3];
			if (!has_addr && plus == 0) { show_bp('B'); return 0; }
			if (!has_addr) return -1;
			if (plus == '-') delete_bp('B', addr);
			else set_bp('B', addr);
			return 0;
		}
#line 3335 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy286:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy284;
	goto yy257;
yy287:
	++YYCURSOR;
#line 1686 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			char plus = cp[3];
			if (!has_addr && plus == 0) { show_bp('M'); return 0; }
			if (!has_addr) return -1;
			if (plus == '-') delete_bp('M', addr);
			else set_bp('M', addr);
			return 0;
		}
#line 3351 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
yy289:
	yych = *++YYCURSOR;
	if (yych <= 0x00) goto yy287;
	goto yy257;
yy290:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'p':	goto yy291;
	default:	goto yy257;
	}
yy291:
	yych = *++YYCURSOR;
	switch (yych) {
	case 0x00:
	case '\t':
	case ' ':	goto yy292;
	default:	goto yy257;
	}
yy292:
	++YYCURSOR;
	YYCURSOR -= 1;
#line 1694 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"
	{
			/* apply a gsbug template to memory */
			/* address\temp name */
			while (isspace(*YYCURSOR)) ++YYCURSOR;
			g_prev_address = debug_apply_template(addr, YYCURSOR);
			return 0;
		}
#line 3381 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_shell.c"
}
#line 1726 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_shell.re2c"

}


int debug_shell(int code) {
	int c;
	char *cp;
	int control_d_count = 0;
	word32 kpc = engine.kpc;

	fflush(stderr);
	fflush(stdout);

	if (!g_templates_loaded) {
		char *path;
		g_templates_loaded = 1;

		path = get_resource_path("GSBug.Templates");
		if (path) {
			debug_load_templates(path);
			free(path);
		}
		path = get_resource_path("NList.Data");
		if (path) {
			debug_load_nifty(path);
			free(path);
		}
	}


	if (code == RET_BP) {

		/* check for temp. breakpoint */
		if (!delete_bp('T', engine.kpc)) {
			printf("Breakpoint hit:\n");
		}
	}
	if (code == RET_MP) {
		printf("Memory breakpoint hit\n");
		switch (g_abort_bytes) {
			case 1: g_abort_value &= 0xff; break;
			case 2: g_abort_value &= 0xffff; break;
			case 3: g_abort_value &= 0xffffff; break;
		} 
		printf("%06x: %0*x\n", g_abort_address, g_abort_bytes * 2, g_abort_value);
	}
	if (code == RET_BRK || code == RET_COP) {
		/* hit a BRK op */
	}
	if (code == RET_HALT) {
		/* halt_printf or ^C */
		fputs("\n", stdout);
	}


	g_prev_stack_address = engine.stack;
	g_prev_stack_bank = engine.kpc & 0xff0000;
	g_prev_address = engine.kpc;
	g_disasm_psr = engine.psr;
	do_list(engine.kpc, 1);

	for(;;) {
		cp = x_readline("] ");
		if (!cp) {
			if (++control_d_count < 2)
				continue;
			fputs("quit\n", stdout);
			fflush(stdout);
			return 0;
		}
		control_d_count = 0;
		if (!*cp) continue;
		c = parse_command(cp);
		if (c < 0) printf("error.\n");
		if (c == 'q') return 0;
		if (c == 1) break;
	}

	if (engine.kpc == kpc) {
		switch(code) {
			case RET_BRK:
			case RET_COP:
				engine.flags |= FLAG_IGNORE_BRK;
				break;
			case RET_MP:
				engine.flags |= FLAG_IGNORE_MP;
				break;
			case RET_BP:
				engine.flags |= FLAG_IGNORE_BP;
				break;
		}	
	}

	return 1;
}

static void do_sig_intr(int sig) {
	if (halt_sim & 4) {
		abort();
	}
	set_halt(4);
}


#ifdef _WIN32
static BOOL WINAPI ctrl_handler(DWORD dwCtrlType) {
	/* handled via a new thread */
	if (dwCtrlType == CTRL_C_EVENT || dwCtrlType == CTRL_BREAK_EVENT) {
		do_sig_intr(SIGINT);
		return TRUE;
	}
	return FALSE;
}
#endif


/* also called by do_step */
void do_go() {
  int ret;
  int ok;

  #ifdef _WIN32
  	SetConsoleCtrlHandler(ctrl_handler, 1);
  #else
  /* if -g flag, start with debug shell ... */
  if (isatty(STDIN_FILENO)) {
  	struct sigaction sa;
  	memset(&sa, 0, sizeof(sa));
  	sigemptyset(&sa.sa_mask);
  	sa.sa_handler = do_sig_intr;
  	sigaction(SIGINT, &sa, NULL);

  } else {
  	g_dbg_shell = 0;  	
  }
  #endif

  g_config_control_panel = 1;
  if (g_dbg_shell) {
  	ok = debug_shell(0);
  	if (!ok) return;
  }

  g_config_control_panel = 0;
  clear_halt();

  for(;;) {

    ret = run_prog();
    if (halt_sim & HALT_WANTTOQUIT) return;

    if (ret || g_stepping) {
      g_config_control_panel = 1;
      ok = debug_shell(ret);
      if (!ok) return;
      g_config_control_panel = 0;
      halt_sim &= ~0x07; /* clear any pending control-Cs, etc. */
    }
  }
}

/* legacy */



void halt_printf(const char *fmt, ...)      {
  va_list args;

  va_start(args, fmt);
  vprintf(fmt, args);
  va_end(args);

  set_halt(1);
}

void halt2_printf(const char *fmt, ...)      {
  va_list args;

  va_start(args, fmt);
  vprintf(fmt, args);
  va_end(args);

  set_halt(2);
}
