/* Generated by re2c 2.2 on Fri May 26 06:50:08 2023 */
#line 1 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
/*
 *
 * Load and parse GSBug templates and Nifty List Data.
 */

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>

#include "defc.h"


#ifdef WIN32
char *strndup(const char *s, size_t maxlen) {
	char *cp;
	size_t l = strlen(s);

	if (l > maxlen) l = maxlen;
	cp = malloc(l + 1);
	if (cp) {
		memcpy(cp, s, l);
		cp[l] = 0;
	}
	return cp;
}
#endif

#line 36 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"



/* format
  _START name
  name [type [size]] *
  _END
 */


struct field {
	char *name;
	int type;
	int count;
};

struct record {
	char *name;
	int total_size; /* total size */
	int field_count; /* # of fields */
	int field_index; /* starting index into the fields array */
};

static struct record *records = NULL;
static int record_count = 0;
static int record_alloc = 0;

static struct field *fields = NULL;
static int field_count = 0;
static int field_alloc = 0;

static int record_compare(const void *a, const void *b) {
	const struct record *aa = a;
	const struct record *bb = b;
	int rv;
	rv = strcasecmp(aa->name, bb->name);
	//if (rv == 0) return aa->total_size - bb->total_size;
	return rv;
}

/* 192 records in the standard file... */
static void add_record(struct record *r) {
	/* calc size and count */
	int i;

	r->field_count = field_count - r->field_index;
	for (i = r->field_index; i < field_count; ++i) {
		int size = fields[i].type;
		if (size > 4) size = 4;
		r->total_size += size * fields[i].count;
	}

	if (record_count == record_alloc) {
		size_t size = (record_alloc + 256) * sizeof(struct record);
		void *tmp = realloc(records, size);
		if (!tmp) return; /* oops */
		records = tmp;
		record_alloc += 256;
	}
	records[record_count++] = *r;
}


/* average ~14 fields per record */
static void add_field(struct field *f) {
	if (field_count == field_alloc) {
		size_t size = (field_alloc + 512) * sizeof(struct field);
		void *tmp = realloc(fields, size);
		if (!tmp) return; /* oops */
		fields = tmp;
		field_alloc += 512;
	}
	fields[field_count++] = *f;
}

static char *rtrim(char *cp) {
	int l = strlen(cp);
	while (l && isspace(cp[l-1])) --l;
	cp[l] = 0;
	return cp;
}

static char *ltrim(char *cp) {
	while (isspace(*cp)) ++cp;
	return cp;
}

/* 0 - no field, 1 - ok, -1 - warning */
static int parse_field(const char *cp, struct field *f) {
	const char *start;
	const char *end;
	const char *YYMARKER = NULL;
	const char *YYCTXMARKER = NULL;

	int type = 0;
	int count = 0;

	start = cp;
	for(;;) {
		
#line 133 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
{
	char yych;
	yych = *cp;
	switch (yych) {
	case 0x00:
	case '\t':
	case '\n':
	case '\r':
	case ' ':	goto yy2;
	default:	goto yy4;
	}
yy2:
	++cp;
#line 136 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ --cp; break; }
#line 149 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy4:
	++cp;
#line 137 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ continue; }
#line 154 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
}
#line 138 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"

	}
	end = cp;
	if (start == end) return 0;

	f->name = strndup(start, end - start);
	f->type = 0;
	f->count = 0;

	while (isspace(*cp)) ++cp;

	/* optional type */
	
#line 170 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
{
	char yych;
	yych = *(YYMARKER = cp);
	switch (yych) {
	case 'B':	goto yy9;
	case 'C':	goto yy11;
	case 'G':	goto yy12;
	case 'L':	goto yy13;
	case 'P':	goto yy14;
	case 'W':	goto yy15;
	default:	goto yy8;
	}
yy8:
#line 157 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ type = 0; goto next; }
#line 186 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy9:
	yych = *++cp;
	switch (yych) {
	case 'Y':	goto yy16;
	default:	goto yy10;
	}
yy10:
	cp = YYMARKER;
	goto yy8;
yy11:
	yych = *++cp;
	switch (yych) {
	case 'S':	goto yy17;
	default:	goto yy10;
	}
yy12:
	yych = *++cp;
	switch (yych) {
	case 'S':	goto yy18;
	default:	goto yy10;
	}
yy13:
	yych = *++cp;
	switch (yych) {
	case 'O':	goto yy19;
	default:	goto yy10;
	}
yy14:
	yych = *++cp;
	switch (yych) {
	case 'S':	goto yy20;
	default:	goto yy10;
	}
yy15:
	yych = *++cp;
	switch (yych) {
	case 'O':	goto yy21;
	default:	goto yy10;
	}
yy16:
	yych = *++cp;
	switch (yych) {
	case 'T':	goto yy22;
	default:	goto yy10;
	}
yy17:
	yych = *++cp;
	switch (yych) {
	case 'T':	goto yy23;
	default:	goto yy10;
	}
yy18:
	yych = *++cp;
	switch (yych) {
	case 'S':	goto yy24;
	default:	goto yy10;
	}
yy19:
	yych = *++cp;
	switch (yych) {
	case 'N':	goto yy25;
	default:	goto yy10;
	}
yy20:
	yych = *++cp;
	switch (yych) {
	case 'T':	goto yy26;
	default:	goto yy10;
	}
yy21:
	yych = *++cp;
	switch (yych) {
	case 'R':	goto yy27;
	default:	goto yy10;
	}
yy22:
	yych = *++cp;
	switch (yych) {
	case 'E':	goto yy28;
	default:	goto yy10;
	}
yy23:
	yych = *++cp;
	switch (yych) {
	case 'R':	goto yy29;
	default:	goto yy10;
	}
yy24:
	yych = *++cp;
	switch (yych) {
	case 'T':	goto yy30;
	default:	goto yy10;
	}
yy25:
	yych = *++cp;
	switch (yych) {
	case 'G':	goto yy31;
	default:	goto yy10;
	}
yy26:
	yych = *++cp;
	switch (yych) {
	case 'R':	goto yy32;
	default:	goto yy10;
	}
yy27:
	yych = *++cp;
	switch (yych) {
	case 'D':	goto yy33;
	default:	goto yy10;
	}
yy28:
	yych = *++cp;
	switch (yych) {
	case 0x00:
	case '\t':
	case '\n':
	case '\r':
	case ' ':	goto yy34;
	default:	goto yy10;
	}
yy29:
	yych = *++cp;
	switch (yych) {
	case 'I':	goto yy36;
	default:	goto yy10;
	}
yy30:
	yych = *++cp;
	switch (yych) {
	case 'R':	goto yy37;
	default:	goto yy10;
	}
yy31:
	yych = *++cp;
	switch (yych) {
	case 0x00:
	case '\t':
	case '\n':
	case '\r':
	case ' ':	goto yy38;
	default:	goto yy10;
	}
yy32:
	yych = *++cp;
	switch (yych) {
	case 'I':	goto yy40;
	default:	goto yy10;
	}
yy33:
	yych = *++cp;
	switch (yych) {
	case 0x00:
	case '\t':
	case '\n':
	case '\r':
	case ' ':	goto yy41;
	default:	goto yy10;
	}
yy34:
	++cp;
	cp -= 1;
#line 151 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ type = 1; goto next; }
#line 351 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy36:
	yych = *++cp;
	switch (yych) {
	case 'N':	goto yy43;
	default:	goto yy10;
	}
yy37:
	yych = *++cp;
	switch (yych) {
	case 'I':	goto yy44;
	default:	goto yy10;
	}
yy38:
	++cp;
	cp -= 1;
#line 153 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ type = 4; goto next; }
#line 369 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy40:
	yych = *++cp;
	switch (yych) {
	case 'N':	goto yy45;
	default:	goto yy10;
	}
yy41:
	++cp;
	cp -= 1;
#line 152 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ type = 2; goto next; }
#line 381 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy43:
	yych = *++cp;
	switch (yych) {
	case 'G':	goto yy46;
	default:	goto yy10;
	}
yy44:
	yych = *++cp;
	switch (yych) {
	case 'N':	goto yy47;
	default:	goto yy10;
	}
yy45:
	yych = *++cp;
	switch (yych) {
	case 'G':	goto yy48;
	default:	goto yy10;
	}
yy46:
	yych = *++cp;
	switch (yych) {
	case 0x00:
	case '\t':
	case '\n':
	case '\r':
	case ' ':	goto yy49;
	default:	goto yy10;
	}
yy47:
	yych = *++cp;
	switch (yych) {
	case 'G':	goto yy51;
	default:	goto yy10;
	}
yy48:
	yych = *++cp;
	switch (yych) {
	case 0x00:
	case '\t':
	case '\n':
	case '\r':
	case ' ':	goto yy52;
	default:	goto yy10;
	}
yy49:
	++cp;
	cp -= 1;
#line 154 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ type = 5; goto next; }
#line 431 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy51:
	yych = *++cp;
	switch (yych) {
	case 0x00:
	case '\t':
	case '\n':
	case '\r':
	case ' ':	goto yy54;
	default:	goto yy10;
	}
yy52:
	++cp;
	cp -= 1;
#line 155 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ type = 6; goto next; }
#line 447 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy54:
	++cp;
	cp -= 1;
#line 156 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ type = 7; goto next; }
#line 453 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
}
#line 158 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"


next:
	while (isspace(*cp)) ++cp;
	if (type) {
		count = 0;
		while(isdigit(*cp)) {
			count = count * 10 + *cp - '0';
			++cp;
		}
		if (!count) count = 1;
	}
	while (isspace(*cp)) ++cp;
	if (*cp != 0) {
		return -1;
	}
	f->type = type;
	f->count = count;
	return 1;
}


void debug_load_templates(const char *path) {
	FILE *f;
	char buffer[1024];
	int ok;
	int in_struct = 0;
	struct record record;
	struct field field;
	unsigned line = 0;
	const char *YYMARKER = NULL;
	const char *YYCTXMARKER = NULL;


	f = fopen(path, "r");
	if (!f)  {
		fprintf(stderr, "Unable to load %s: %s\n", path, strerror(errno));
		return;
	}
	for (line = 1;;++line) {
		const char *start = NULL;
		const char *end = NULL;

		const char *cp = fgets(buffer, sizeof(buffer), f);
		if (!cp) break;
		rtrim(buffer);

		
#line 504 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
{
	char yych;
	yych = *(YYMARKER = cp);
	switch (yych) {
	case 0x00:	goto yy59;
	case '\t':
	case '\n':
	case '\r':
	case ' ':	goto yy61;
	case ';':	goto yy64;
	case '_':	goto yy66;
	default:	goto yy58;
	}
yy58:
#line 206 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ goto _field; }
#line 521 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy59:
	++cp;
#line 208 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ continue; }
#line 526 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy61:
	yych = *++cp;
	switch (yych) {
	case 0x00:	goto yy59;
	case '\t':
	case '\n':
	case '\r':
	case ' ':	goto yy61;
	default:	goto yy63;
	}
yy63:
	cp = YYMARKER;
	goto yy58;
yy64:
	++cp;
#line 207 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ continue; }
#line 544 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy66:
	yych = *++cp;
	switch (yych) {
	case 'E':	goto yy67;
	case 'S':	goto yy68;
	default:	goto yy63;
	}
yy67:
	yych = *++cp;
	switch (yych) {
	case 'N':	goto yy69;
	default:	goto yy63;
	}
yy68:
	yych = *++cp;
	switch (yych) {
	case 'T':	goto yy70;
	default:	goto yy63;
	}
yy69:
	yych = *++cp;
	switch (yych) {
	case 'D':	goto yy71;
	default:	goto yy63;
	}
yy70:
	yych = *++cp;
	switch (yych) {
	case 'A':	goto yy72;
	default:	goto yy63;
	}
yy71:
	yych = *++cp;
	switch (yych) {
	case 0x00:
	case '\t':
	case '\n':
	case '\r':
	case ' ':	goto yy73;
	default:	goto yy63;
	}
yy72:
	yych = *++cp;
	switch (yych) {
	case 'R':	goto yy75;
	default:	goto yy63;
	}
yy73:
	++cp;
	cp -= 1;
#line 209 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ goto _end; }
#line 597 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy75:
	yych = *++cp;
	switch (yych) {
	case 'T':	goto yy76;
	default:	goto yy63;
	}
yy76:
	yych = *++cp;
	switch (yych) {
	case 0x00:
	case '\t':
	case '\n':
	case '\r':
	case ' ':	goto yy77;
	default:	goto yy63;
	}
yy77:
	++cp;
	cp -= 1;
#line 210 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ goto _start; }
#line 619 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
}
#line 211 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"


_field:
		if (!in_struct) {
			/* warn once */
			fprintf(stderr, "%s:%d: Missing _START.\n", path, line);
			memset(&record, 0, sizeof(record));
			in_struct = -1;
		}
		if (in_struct < 0) continue;

		memset(&field, 0, sizeof(field));
		ok = parse_field(cp, &field);
		if (ok == 0) continue;
		if (ok < 1) {
			/* warn but add */
			fprintf(stderr, "%s:%d: Bad field line: %s\n", path, line, buffer);
		}
		add_field(&field);
		continue;

_start:
		if (in_struct) {
			/* warn and close it */
			if (in_struct > 0) add_record(&record);
		}
		memset(&record, 0, sizeof(record));

		while (isspace(*cp)) ++cp;
		start = cp;
		for(;;) {
			
#line 654 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
{
	char yych;
	yych = *cp;
	switch (yych) {
	case 0x00:
	case '\t':
	case '\n':
	case '\r':
	case ' ':	goto yy81;
	default:	goto yy83;
	}
yy81:
	++cp;
#line 243 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ --cp; break; }
#line 670 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy83:
	++cp;
#line 244 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ continue; }
#line 675 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
}
#line 245 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"

		}
		end = cp;
		if (start == end) {
			/* warning ... */
			fprintf(stderr, "%s:%d: _START missing name.\n", path, line);
			in_struct = -1;
		} else {
			in_struct = 1;
			record.name = strndup(start, end - start);
			record.field_index = field_count;
		}

		while (isspace(*cp)) ++cp;
		if (*cp != 0) {
			/* warning */
			fprintf(stderr, "%s:%d: Bad _START line: %s\n", path, line, buffer);
		}
		continue;

_end:
		while (isspace(*cp)) ++cp;
		if (*cp != 0) {
			/* warning ... */
			fprintf(stderr, "%s:%d: Bad _END line: %s\n", path, line, buffer);
		}

		if (in_struct) {
			if (in_struct > 0) add_record(&record);
		} else {
			/* warning */
			fprintf(stderr, "%s:%d: _END without _START.\n", path, line);
		}
		in_struct = 0;
		memset(&record, 0, sizeof(record));

		continue;
	}

	if (in_struct) {
		/* warn & close */
		fprintf(stderr, "%s:%d: Missing _END.\n", path, line);
		if (in_struct > 0) add_record(&record);
	}
	fclose(f);

	qsort(records, record_count, sizeof(struct record), record_compare);
}

static int record_search(const void *a, const void *b) {
	const struct record *r = b;
	return strcasecmp(a, r->name);
}

static void print_string(int type, word32 address) {

	unsigned c;
	unsigned length;
	unsigned more = 0;
	if (!address) return;
	fputc('"', stdout);


	switch(type) {
		case 5:
			length = 32;
			break;
		case 6:
			length = get_memory_c(address, 0);
			++address;
			break;
		case 7:
			length = get_memory16_c(address, 0);
			address += 2;
			break;
	}
	if (length > 32) {
		length = 32;
		more = 1;
	}

	for (unsigned i = 0; i < length; ++i) {
		c = get_memory_c(address++, 0);
		if (type == 5 && c == 0) break;

		if ((~c & 0x80) && isprint(c)) {
			fputc(c, stdout);
		} else fprintf(stdout, "\\x%02x", c);
	}

	if (type == 5 && c != 0) more = 1;
	if (more) fputs("...", stdout);

	fputc('"', stdout);
	fputc(' ', stdout);

}
word32 debug_apply_template(word32 address, const char *name) {
	/* 1 - lookup template */
	struct record *r;
	int i, j;
	struct field *f;

	r = bsearch(name, records, record_count, sizeof(struct record), record_search);
	if (r == NULL) {
		fprintf(stderr, "Invalid template: %s\n", name);
		return address;
	}
	f = fields + r->field_index;
	if (r->total_size == 0) {
		/* just print the fields */
		for (i = 0; i < r->field_count; ++i) {
			fputs(f[i].name, stdout);
			fputc('\n', stdout);
		}
		fputc('\n', stdout);
		return address;
	}

	for (i = 0; i < r->field_count; ++i) {
		word32 value;
		unsigned type = f[i].type;
		printf("%-16s", f[i].name);
		for (j = 0; j < f[i].count; ++j) {
			switch(type) {
				case 1:
					value = get_memory_c(address, 0);
					address += 1;
					printf("%02x ", value);
					break;
				case 2:
					value = get_memory16_c(address, 0);
					address += 2;
					printf("%04x ", value);
					break;
				case 4:
				case 5: /* cstring */
				case 6: /* pstring */
				case 7: /* gs/os string */
					value = get_memory24_c(address, 0);
					address += 4;
					printf("%08x ", value);
					if (type > 4) {
						print_string(type, value);
					}
					break;
			}
			address &= 0xffffff;
		}
		fputc('\n', stdout);
	}
	fputc('\n', stdout);
	return address;
}



struct tool {
	char *name;
	char *fullname;
	unsigned number;
	unsigned vector;
};

struct tool *tools = NULL;
int tool_count = 0;
int tool_alloc = 0;



struct tool *tool_names = NULL;
int tool_name_count = 0; 


static void add_tool(struct tool *t) {
	if (tool_count == tool_alloc) {
		size_t size = (tool_alloc + 1024) * sizeof(struct tool);
		void *tmp = realloc(tools, size);
		if (!tmp) return;
		tools = tmp;
		tool_alloc += 1024;
	}
	tools[tool_count++] = *t;
}


static word32 to_hex(const char *iter, const char *end) {
	word32 rv = 0;
	while(iter != end) {
		char c = *iter++;
		rv <<= 4;
		if (isdigit(c)) rv |= c - '0';
		else rv |= (c | 0x20) - 'a' + 10;
	}
	return rv;
}

static int tool_compare(const void *a, const void *b) {
	const struct tool *aa = a;
	const struct tool *bb = b;

	int rv = (int)aa->vector - (int)bb->vector;
	if (rv == 0) rv = (int)aa->number - (int)bb->number;
	return rv;
}

static int tool_name_compare(const void *a, const void *b) {
	const struct tool *aa = a;
	const struct tool *bb = b;

	int rv = (int)aa->vector - (int)bb->vector;
	if (rv == 0) rv = strcasecmp(aa->name, bb->name);
	return rv;
}


/* nifty list */
/*
 * format: 
 * fffx ... header comments
 * xxxx name ; p8 mli calls 
 * *
 * xxxx name ; p16/gsos calls
 * *
 * xxxx name ; tool calls
 * *
 * xxxx name ; user tool calls
 * *
 * xxxx name ; e1 vectors
 * *
 * xxxx name ; e0 vectors
 * *
 * xxxx name ; softswitch/f8 rom
 * *
 * xxxx name ; 01 vectors
 * *
 * xxxx name ; nifty list service calls
 * *
 * xxxx name ; resource types
 * *
 * xxxx name ; error codes
 * *
 * xxxx name ; HC IIgs callbacks 
 * *
 * xxxx name ; request codes
 * *
 *
 */

void debug_load_nifty(const char *path) {

	FILE *f;
	char buffer[1024];
	unsigned line = 0;
	const char *YYMARKER = NULL;
	const char *YYCTXMARKER = NULL;

	int section = 0;
	unsigned vector = 0;
	static unsigned vectors[] = {
		0xbf00, 0xe100a8, 0xe10000, 0xe10008, 0xe1, 0xe0, 0xff, 0x01,
		0x00, 0x00, 0x00, 0x00, 0x00
	};


	f = fopen(path, "r");
	if (!f)  {
		fprintf(stderr, "Unable to load %s: %s\n", path, strerror(errno));
		return;
	}
	for (line = 1;;++line) {
		const char *start;
		const char *end;
		struct tool tool = { 0, 0, 0, vector };

		const char *cp = fgets(buffer, sizeof(buffer), f);
		if (!cp) break;
		rtrim(buffer);

		start = cp;
		
#line 959 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
{
	char yych;
	yych = *cp;
	switch (yych) {
	case 0x00:
	case '\n':
	case '\r':	goto yy87;
	case '*':	goto yy91;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy93;
	default:	goto yy89;
	}
yy87:
	++cp;
#line 526 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ continue; }
#line 996 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy89:
	++cp;
yy90:
#line 527 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{
				fprintf(stderr, "%s:%d: Bad line: %s", path, line, buffer);
				continue;
			}
#line 1005 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy91:
	++cp;
#line 531 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{
				++section;
				vector = 0;
				if (section < sizeof(vectors) / sizeof(vectors[0]))
					vector = vectors[section];
				continue;
			}
#line 1016 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy93:
	yych = *(YYMARKER = ++cp);
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy94;
	default:	goto yy90;
	}
yy94:
	yych = *++cp;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy96;
	default:	goto yy95;
	}
yy95:
	cp = YYMARKER;
	goto yy90;
yy96:
	yych = *++cp;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy97;
	default:	goto yy95;
	}
yy97:
	yych = *++cp;
	switch (yych) {
	case '\t':
	case '\n':
	case '\r':
	case ' ':	goto yy98;
	default:	goto yy95;
	}
yy98:
	++cp;
	cp -= 1;
#line 538 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ goto ok; }
#line 1115 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
}
#line 539 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"

ok:
		end = cp;
		tool.number = to_hex(start, end);
		if (section == 0 && tool.number >= 0xfff0) continue;
		if (!vector) continue;

		while (isspace(*cp)) ++cp;
		/* skip p8/p16/ prefix */
		
#line 1128 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
{
	char yych;
	yych = *(YYMARKER = cp);
	switch (yych) {
	case 'G':	goto yy103;
	case 'P':	goto yy105;
	case 'S':	goto yy106;
	default:	goto yy102;
	}
yy102:
#line 550 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ goto prefix; }
#line 1141 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy103:
	yych = *++cp;
	switch (yych) {
	case 'S':	goto yy107;
	default:	goto yy104;
	}
yy104:
	cp = YYMARKER;
	goto yy102;
yy105:
	yych = *++cp;
	switch (yych) {
	case '1':	goto yy108;
	case '8':	goto yy109;
	default:	goto yy104;
	}
yy106:
	yych = *++cp;
	switch (yych) {
	case 'h':	goto yy110;
	default:	goto yy104;
	}
yy107:
	yych = *++cp;
	switch (yych) {
	case '/':	goto yy111;
	default:	goto yy104;
	}
yy108:
	yych = *++cp;
	switch (yych) {
	case '6':	goto yy109;
	default:	goto yy104;
	}
yy109:
	yych = *++cp;
	switch (yych) {
	case ':':	goto yy112;
	default:	goto yy104;
	}
yy110:
	yych = *++cp;
	switch (yych) {
	case 'e':	goto yy114;
	default:	goto yy104;
	}
yy111:
	yych = *++cp;
	switch (yych) {
	case 'O':	goto yy115;
	default:	goto yy104;
	}
yy112:
	++cp;
#line 549 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ goto prefix; }
#line 1198 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy114:
	yych = *++cp;
	switch (yych) {
	case 'l':	goto yy116;
	default:	goto yy104;
	}
yy115:
	yych = *++cp;
	switch (yych) {
	case 'S':	goto yy109;
	default:	goto yy104;
	}
yy116:
	yych = *++cp;
	switch (yych) {
	case 'l':	goto yy109;
	default:	goto yy104;
	}
}
#line 551 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"

prefix:
		start = cp;
		for(;;) {
			
#line 1224 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
{
	char yych;
	yych = *cp;
	switch (yych) {
	case 0x00:	goto yy119;
	case '\t':
	case '\n':
	case '\r':
	case ' ':
	case '(':	goto yy123;
	default:	goto yy121;
	}
yy119:
	++cp;
	cp -= 1;
#line 556 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ break; }
#line 1242 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy121:
	++cp;
#line 564 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{ continue; }
#line 1247 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
yy123:
	++cp;
#line 557 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"
	{
				if (vector > 0x100 ) {
					--cp;
					break;
				}
				continue;
			}
#line 1258 "/usr/src/RPM/BUILD/gsplus-0.14/x86_64-alt-linux/bin/debug_template.c"
}
#line 565 "/usr/src/RPM/BUILD/gsplus-0.14/src/debug_template.re2c"

		}
		end = cp;
		if (end > start) {
			int l = end - start;


			tool.fullname = NULL; 
			if (vector > 0x0100) {
				/* add a leading _ */
				tool.name = malloc(l + 2);
				tool.name[0] = '_';
				strncpy(tool.name + 1, start, l);
				tool.name[l + 1] = 0;
				tool.fullname = strdup(start);
			}
			else tool.name = strndup(start, l);
			add_tool(&tool);
		}


	}
	fclose(f);

	qsort(tools, tool_count, sizeof(struct tool), tool_compare);

	/* name index for tools and gs/os calls */

	int tmp = 0;
	int i;
	for (i = 0; i < tool_count; ++i) {
		unsigned v = tools[i].vector;
		if (v == 0xe10000 || v == 0xe100a8 || v == 0xbf00)
			++tmp;
	}
	if (!tmp) return;
	tool_name_count = tmp;
	tool_names = malloc(sizeof(struct tool) * tmp);
	if (!tool_names) return;
	tool_name_count = tmp;
	tmp = 0;
	for(i = 0; i < tool_count; ++i) {
		unsigned v = tools[i].vector;
		if (v == 0xe10000 || v == 0xe100a8 || v == 0xbf00)
			tool_names[tmp++] = tools[i];
	}
	qsort(tool_names, tool_name_count, sizeof(struct tool), tool_name_compare);
}

const char *debug_tool_name(unsigned number, unsigned vector, unsigned full) {

	if (!tool_count) return NULL;

	struct tool tmp = { 0, 0, number, vector };
	struct tool *t = bsearch(&tmp, tools, tool_count, sizeof(struct tool), tool_compare);
	if (!t) return NULL;
	if (full && t->fullname) return t->fullname;
	return t->name;
}


int lookup_tool_number(const char *name, unsigned vector) {

	if (!tool_name_count) return 0;

	struct tool tmp = { (char *)name, 0, 0, vector};
	struct tool *t = bsearch(&tmp, tool_names, tool_name_count, sizeof(struct tool), tool_name_compare);
	if (!t) return 0;
	return t->number;
}
